Analyst Fact Workbench Overview

Analyst Fact Workbench

The Analyst Fact Workbench is designed to assist software developers scope a project, develop an initial set of requirements and identify the key events, objects and processes relevant to the development of a system specification.

The Analyst Fact Workbench holds a series of inter-related facts, which include organisational units, stakeholders, problems, requirements, events, objects and processes. Tools are available to cross-reference facts and so develop a consistent system description. A validation tool reports on inconsistencies and omissions in the description.

As the early stages of system development are an inherently co-operative activity, a number of facilities are provided to enable team working, especially in agreement of requirements and management of the work programme. In addition, users can communicate with one another through pre-defined or free-form emails, as well as develop a list of issues, each of which can be assigned to a user to resolve.

Further information on the Analyst Fact Workbench is available at www.co.umist.ac.uk/~pjl/resources/AFW.


Initial Setup

The Analyst Fact Workbench is implemented using Microsoft Access 2000. Users of the Workbench will need to have the appropriate run-time files installed.


Getting Started

When the Analyst Fact Workbench is started for the first time, the Workbench will enter a special project set-up screen in which the basic project details and team member details must be entered.

Enter the title of the project, the name of the team and client details.

For each team member (up to a maximum of 10), enter a unique user ID, their first name and surname and their email address.

After the details have been entered and verified, press the 'Save parameters and exit' button. The Workbench will save the details and exit. The system will then be ready for normal operation.

You can amend the project details from the main system control panel by selecting the Project details button.


Logging On

Before you can start to use the Analyst Fact Workbench, you must log on. After a start-up splash logo, the Workbench will display a log-on dialogue box.

Use the pull-down list to identify your name. Your name should have been entered when the project was set-up. If your name was not initially included in the team members list, an existing member of the team or your project supervisor will need to add your name.

After selecting your name from the pull-down list, press Tab or Return to move to the next field.

If you are using Workbench for the first time, you will not have a password and so you can enter anything in this field or leave it blank. At other times, you must enter the password you have previously selected (see below).

After selecting your name and entering a password, press the Continue button.

If you are using Workbench for the first time, you will then be prompted to enter a personal password which must be supplied every time you use the Workbench.

The Special button is to enable the project supervisor to access the system. Further details can be found on the special log-in page.


Control Panel

Analyst Fact Workbench Control Panel

The Control Panel is the main system menu for the Analyst Fact Workbench, bringing together a range of system functions and data indicators.

The key groups of functions are:

  • Fact Base Editing which enables the editing of basic facts held in the fact base and enables the cross-referencing of appropriate facts
  • Requirements Voting which enables team members to vote on the relative importance of each requirements
  • Requirements Allocation which enables team members to classify requirements into user-defined categories
  • Analysis and Reports which enables the generation of range of reports
  • Project Management which enables team members to communicate by email, record their work activities against a process model, record and manage project questions and issues and permits the project supervisor to undertake certain restricted administrative activities
  • Checkpointing which enables team members to be updated on changes made to the fact base since they last used the system
  • Changing Your Password
  • Project Completion which performs certain end of projects activities.


Fact Base Editing

At the heart of the Analyst Fact Workbench is a database which holds a series of facts about a system. These facts are classified into a series of types, for each one of which, an entry can be created and appropriate details and cross-references recorded.

The fact types which can be held by the Analyst Fact Workbench are:

  • Organisational units
  • Stakeholders
  • Problems
  • Constraints
  • Requirements
  • Events
  • Objects
  • Processes

The fact base editing functions of the main control panel display the number of facts recorded by the Workbench in each category of fact and provides a button to switch to the appropriate editor for each fact type. In addition, buttons are provided to manage the prioritisation of requirements and to view the results of prioritisation.


Analysis and Reports

A key feature of the Analyst Fact Workbench is to assist developers in maintaining the consistency and completeness of the fact base so that its details can be subsequently used to develop a system specification.

The Validation and Reports section of the control panel provides a series of options for viewing the contents of the fact base and checking its consistency. The current number of validation errors are shown on the control panel and a detailed validation report can be produced by selecting the Validation button.

A list of all named facts in the fact base, together with their types can be produced by selecting the Directory button. See the directory page for further details.

The Reports button invokes the report generator, in which user can chose from a series of reports to be printed.


Project Management

The project management functions available from the main control panel enables users to monitor and control a project's development.

As a key activity during the initial development of a project is dealing with uncertainties, the Analyst Fact Workbench provides an explicit mechanism by which such issues can recorded, assigned to a team member to resolve and to record an outcome. Issues are accessed by pressing the ISSUES button. The number of outstanding issues for the project as a whole and the number of unresolved issues assigned to the current user are shown on the control panel.

Underlying the Analyst Fact Workbench is a suggested ordered set of activities. These activities are pre-defined, but can be amended by the project supervisor. The activities can be viewed by pressing the ACTIVITIES button.

The ACTIVITY LOG button enables team members to record the activities they have undertaken and include the time spent on each activity session. A summary report can be generated.

Amending the project details, including team membership, can be achieved by pressing the PROJECT DETAILS button.

To enable email communication between team members, press the COMMUNICATIONS button. A series of pre-defined email message can be selected and despatch to team members.

The SYSTEM button enables project supervisors to access key set-up and installation parameters, provided an appropriate password is supplied.


Requirements Completion

The main control panel of the Analyst Fact Workbench shows how far each team member has reached in their individual prioritisation of requirements voting.

100% indicates that the team member has prioritised all possible combinations of requirements, whilst a blank entry indicates that no requirements have yet been prioritised.


Requirements Voting

Requirements voting enables each team member to express their opinion as to the priority of requirements held in the fact base.

AFW supports two voting methods, pair-wise comparison and multi-weight voting. Projects can opt to use one or both methods. The control panel enables users to select their preferred voting method.

The main control panel also shows how far each team member has progressed with their voting on requirements and the RESULTS button shows the ranked order of requirements.


Requirements Priority

Requirements voting enables each team member to express their opinion as to the priority of requirements held in the fact base. Two methods of prioritisation are possible, pair-wise comparison or multi-weight voting, depending upon the option selected on the control panel.

At any point after at least two requirements have been prioritised by one team member, the Results button on the main control panel will show a ranked order of the requirements priorities. The percentage figures shows the relative importance of the requirement over all other requirements, where 100% indicates absolute importance.

The Requirements Analysis Summary window, which is produced by pressing the Results button, allows individual requirements to be selected and the requirements editor invoked.

If multi-weight voting is employed, a report can be generated showing significant differences between the votes allocated by users.


Pair-wise Comparison

Requirements Voting by Pair-Wise Comparison

In pair-wise comparison voting, each pair of requirements is compared and a statement on the relative importance of one requirement over the other is expressed (as shown in the drop-down list below).

This method of voting is better than multi-weight voting, but becomes impractical with large numbers of requirements.

The main control panel shows how far each team member has progressed with their voting on requirements and the RESULTS button shows the ranked order of requirements.


Multi-weight Voting

Requirements Voting by Multi-Weight Voting

In multi-weight voting, each user is allocated a number of weights (points) which can be allocated to the set of requirements. The total number of weights available is calculated as 10 * (the number of requirements). Users can allocate as many of their weights to a requirement as they wish- the greater the number of weights , the more important the requirement. Users can also allocate zero weights to requirements which they believe are unimportant or irrelevant to their area of activity. The total number of weights must not be exceeded.

Where a user allocates weights with a specific reason in mind, they can add a comment (which will appear in the appropriate report). Comments are added by selecting the appropriate requirement on the vertical selection bar on the left hand side of the screen and selecting the Comment on voting button.

This method of voting is better than pair-wise comparison when there is a large number of requirements to process.

The main control panel shows how far each team member has progressed with their voting on requirements and the RESULTS button shows the ranked order of requirements.


Allocate Requirements

In a large project with many requirements, it can be necessary to divide requirements into categories, for example, to help identify potential sub-systems.

AFW provides up to 8 requirement Bins, which can be used to allocate requirements. The allocation mechanism is accessed by selecting the Allocate button on the main control panel.

Using the navigation buttons, users can scroll though the project's requirements. Selecting one of the buttons Bin 1, Bin 2 etc. will cause the current requirement to be allocated to the selected Bin.

Selecting the Remove from bin, will cause the current requirement to be removed from the bin to which it is currently allocated.

To edit the names of each Bin or to completely clear the contents of a Bin, select the Edit Bins button.


Requirement Bins

Requirement Bin

In a large project with many requirements, it can be necessary to divide requirements into categories, for example, to help identify potential sub-systems.

AFW provides up to 8 requirement Bins, which can be used to allocate requirements. The allocation mechanism is accessed by selecting the Allocate button on the main control panel.

To set-up the requirement bins and assign meaningful names to each bin, select the Edit Bins button from the Allocate Requirements screen. When selected, the following edit screen will appear, allowing the bin name and description to be edited.

Select the Empty bin button to clear the contents of the current bin.


Checkpointing

Checkpointing is a mechanism whereby each team member can ask the Analyst Fact Workbench to 'remember' what facts have been recorded in the fact base. On subsequent uses of the Analyst Fact Workbench you can then ask for a list of changes which have been made since the last checkpoint.

The Checkpoint section of the control panel shows how many facts have been created, updated or deleted since the current user's last checkpoint and by pressing the Print changes button, a user can be provided with the details of changes made.

Pressing the New Checkpoint button will create a new checkpoint and the change counts displayed on the control panel will be reset to zero until such time as changes are made to the fact base. Note that it is not possible to undo a checkpoint.


Changing Your Password

You can change your password once you have logged on to the Analyst Fact Workbench. Select the Change password button from the main control panel and follow the system prompts which will ask you to enter your old password, enter a new password and then reconfirm your new password.

If you have forgotten your password and cannot log on to the Workbench, you will need to contact your project supervisor.


Project Completion

The project completion section of the control panel provides a series of functions that may be required before a project can be completed.

Pressing the Feedback button initiates a dialogue in which team members can provide feedback on the performance of the team and team members.

Pressing the Finalise button initiates a series of actions which will prepare the fact base prior to project completion.

Details of the feedback and finalise processes will be provided by project supervisors. Project supervisors may set an earliest start date when the Feedback and Finalise buttons can be activated. For further information on this facility, see the project supervisor's system parameters page.


Organisational unit

Organisational Units

An organisational unit is a department, section or function within a business which carries out business functions. These functions are carried out in order to achieve one or more goals associated with the unit, but which might be hindered because of a problem.

Organisational units will typically be assigned resources which are used in the execution of business functions.

Organisational units are important because the outcomes from your fact analysis will typically be reported by organisational unit and stakeholder. The output reports from the Analyst Fact Workbench are therefore often structured in this way.

Tip

Organisational units are a good starting point to carry out fact analysis. You should normally be able to find out the basic structure of a business using an organisation or department chart. Once you have the basic organisational unit structure, you can start to identify the key stakeholders within the unit and from them, their problems and requirements.

Editing Organisational Units

To create, amend or delete facts about organisational units, select the Units button from the main control panel.

See also

Organisational units editor


Stakeholders

A stakeholder is a person, agent or other person with any interest in the business and hence in the system to be developed.

Stakeholders can be divided into a number of categories:

  • a primary stakeholder is a stakeholder with a direct interest in the business or system and will use the system in some form or other
  • a secondary stakeholder is a stakeholder with an indirect interest in the business or system and will benefit from the operational of the system, normally via primary stakeholder
  • a tertiary stakeholder is a stakeholder who has responsibility for primary stakeholders, for example, as their manager, as a shareholder or as somebody who is commissioning or paying for a new system.

Primary and tertiary stakeholders should belong to an organisational unit.

A stakeholder will normally have one or more goals they seek to achieve in their role. Sometimes such goals can be found embedded in a job description. Associated with these goals will be a series of issues which hinder the achievement of each goals- these are known as problems and can be recorded and assigned to the relevant stakeholder.

Tip

Use the organisational unit structure to identify the main stakeholders in each unit and then systematically analyse each stakeholder to identify their key problems.

Editing Stakeholders

To create, amend or delete facts about Stakeholders, select the STAKEHOLDERS button from the main control panel.

See also

Stakeholders editor


Problems

A problem is a hindrance or difficulty which prevents an organisational unit or stakeholder achieving one or more of their goals.

When identifying a problem, it is important to separate out a number of issues. A problem's description should ensure that it outlines the root cause of the problem, answering the question "why does this problem occur?" This should be distinct from the symptoms of the problem which describe how the problems is "seen" to occur. For example, if you have a cold virus (the problem), the symptom might be a runny nose. Finally, each problem will have an impact on the business and is a description of the extent to which the problem is damaging the achievement of business goals.

Not all problems will be equal in terms of their severity and impact on the business. Some problems will have solutions that enable stakeholders to work-around them, whilst others may have no immediate solution. Problem can therefore be categorised into a a series of levels: desirable, workable, severe and critical. See problem types for further information.

Tip

Use the organisational unit structure to identify the main stakeholders in each unit and then systematically analyse each stakeholder to identify their key problems. You should expect more than one stakeholder to experience some of the problems recorded.

Interviewing stakeholders is a good way to identify problems, using questions such as:

  • what are the major obstacles to you achieving your goals?
  • how can you measure the impact that a problem has on your work?
  • who else is affected by this problem?

Editing Problems

To create, amend or delete facts about Problems, select the Problems button from the main control panel.

See also

Problem editor


Constraints

A constraint is a restriction or limitation on the way in which an organisational unit, stakeholder or business process can operate, which is outside the immediate control of the business. Typically a constraint will be a binding contract, law or agreement which imposes conditions.

Tip

To identify constraints, use the organisational unit and stakeholders list and identify (by asking them for example) what external constraints are they subject to- these might be legal constraints, business or trade agreements, or custom and practice.

Editing Constraints

To create, amend or delete facts about Constraints, select the Constraints button from the main control panel.

See also

Constraint editor


Requirements

A requirement is a specific want or goal which needs to be achieved by an organisational unit or stakeholder. Typically requirements will be associated with the problems associated with the organisational unit or stakeholder.

Prioritising Requirements

Requirements are a matter of judgement by both stakeholders and developers. Inevitably there will be some requirements which are more important than others, whilst some may be in direct conflict with others.

An important step in managing requirements is to adopt a formal procedure of prioritising requirements. The Analyst Fact Workbench allows users to 'vote' on the relative importance of requirements and achieve an overall consensus.

Tip

Make sure that the requirements you identify are "SMART" requirements: Specific, Measurable, Achievable, Realistic and Time-appropriate. Specific requirements are those meet the other SMART criteria, but essentially are expressed in a definite form- for example, as "increase sales by 10%" rather than as "more sales". Measurable requirements are those which can be measured- for example, as "I want an extra 60 minutes leisure time per working day" rather than as "I want to be happier". In the context of the development of information system, achievable requirements are those which can be delivered through the implementation of an information system. Time-appropriate requirements are those which can be delivered in an appropriate business timescale.

Editing Requirements

To create, amend or delete facts about Requirements, select the Requirements button from the main control panel.

See also

Requirements editor


Events

An event is an instantaneous point in time when something of interest happens. It is instantaneous because it marks the point at which something which was not true, becomes true; for example, 'parcel arrives'.

For all events, it should be possible to identify a control message, which is the means by which the event can be identified to have occurred. For example, the arrival of a parcel might be a 'knock at the house door' or the 'receipt of a delivery document'. In turn, a source of the control message can be identified, i.e. what is the origin of the control message- for example, 'the postman'.

Each event will carry with it some data which describes the event in more detail- for example, the name of the sender of a parcel, the weight of the parcel and the date the parcel arrived.

Whilst initially events may be identified in isolation, over time they will become assigned to objects. Assignment to an object means that the assigned objects is affected in some way by the event. In some cases, events may be assigned to more than one object; such events are known as common events (i.e. they are common to more than one object).

Once an event has occurred, it will normally start a process which uses the data carried by the event to carry out some internal system processing, e.g. 'record the receipt of a parcel'.

Tip

Because an event is an instantaneous point in time, the names of events should not describe actions nor end with the suffix '-ing'. For example, 'generating a customer order' is not an event (it is a process). The correct event would be something like 'customer order generated' indicating that some has happened rather than is happening.

You can identify events by asking stakeholders "when do you that?" or "what causes you to do that?"

Editing Events

To create, amend or delete facts about Events, select the Events button from the main control panel.

See also

Events editor


Objects

An object is something of interest, which can be described and about which we want to record data. The term "thing" or "entity" can also be used for the concept of an object.

Objects are things which are going to be stored in a database or file and which will be subject to processing by system processes. Each object therefore has a set of attributes or data by which specific instances can be characterised, described and identified.

Each object will also be the subject of one or more events. For example, an object such as 'parcel' might be subject to a number of events such as 'parcel created', 'parcel despatched', 'parcel delivered', 'parcel received' and 'parcel opened'.

Avoid Confusion!

In the Analyst Fact Workbench, we are considering concepts which exist before any formal system specification is developed. Therefore when the term object is used, it refers to the general notion of 'something' rather than the more precise notion an 'object' in the object-oriented paradigm.

Tip

To identify objects, first look at all the events in the fact base and identify those which have data in common. Particularly look for that data which is used to identify something or somebody (for example, customer reference, account number or product ID). These 'identifying' data items point to an object (for example, customer, account and product).

Objects can also be identified by examining the data that describes an object. Consider each data item in turn and ask "can a data value exist for this item independently of the objects it describes?" For example, if you have an object such as a 'book' with data items 'title' and 'author', it might be possible for 'author' to exist without being linked to the specific book.

Editing Objects

To create, amend or delete facts about Objects, select the Objects button from the main control panel.

See also

Object editor


Processes

A process is an activity which happens within a business or system which creates, read, updates or deletes one or more objects. These actions are often referred to a CRUD (for Create, Read, Update, Delete). For further information on CRUD operation types, see the CRUDpage.

A process will be started by an event (from outside the system), to which the process responds. Such an event might be some new information about an object or a request for some output from the system

Tip

A process can be identified by examining each event and asking "what happens as a result of this event occurring?"

Editing Processes

To create, amend or delete facts about Processes, select the Processes button from the main control panel.

See also

CRUD

Process editor


Organisational units editor

Editing Organisational Units

Invoking the Organisational Units Editor

To create, amend or delete facts about organisational units, select the Units button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Functions

The Stakeholders tab displays a list of stakeholders assigned to the organisational unit. To assign further stakeholders, you need to use the Stakeholder editor.

Validation

An organisational unit should have at least one assigned stakeholder.

See also

Organisational units


Stakeholders editor

Editing Stakeholders

Invoking the Stakeholders Editor

To create, amend or delete facts about stakeholders, select the Stakeholders button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Fields

The Unit can be used to associate a stakeholder to an organisational unit. A unit name must be selected from the drop-down list. if the unit name does not exist, select the Add Unit button to create a new organisational unit.

Specific Functions

The Problems tab displays a list of problems assigned to the stakeholder.

To assign further problems, select the Assign problem button. A list of problems will be displayed from which one can be selected from the drop-down list.

To deassign a problem from a stakeholder, select the problem by clicking on the box to the left of the problem name. A small arrow will point to the selected problem. Press Deassign problem to remove the problem from the stakeholder's list.

Validation

A stakeholder must belong to one organisational unit.

See also

Stakeholders

Problems


Problem editor

Editing Problems

Invoking the Problem Editor

To create, amend or delete facts about problem, select the Problems button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Fields

Fields are available for a problem description, symptoms and business impact. These concepts are described in detail in the general section on problems.

Not all problems will be equal in terms of their severity and impact on the business. Some problems will have solutions that enable stakeholders to work-around them, whilst others may have no immediate solution. Problem can therefore be categorised into a a series of levels: desirable, workable, severe and critical. See problem types for further information.

The check box, out of scope should be selected if the problem is deemed to be inappropriate for the proposed system.

Specific Functions

The Requirements tab displays a list of requirements which address the problem.

To assign a requirement, select the Assign requirement button. A list of requirements will be displayed from which one can be selected from the drop-down list.

To deassign a requirement from a problem, select the requirement by clicking on the box to the left of the requirement name. A small arrow will point to the selected requirement. Press Deassign requirement to remove the requirement from the problem's list.

Selecting Edit requirement will invoke the Requirements editor for the currently highlighted requirement.

Validation

A problem must be addressed by at least one requirement unless it is out of scope.

See also

Problems

Requirements


Constraints editor

Editing Constraints

Invoking the Constraint Editor

To create, amend or delete facts about constraints, select the Constraints button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Functions

The Impact Upon Processes tab displays a list of processes affected by the constraint. To assign further processes impacted by the constraint, you need to use the Process editor.

See also

Constraints


Requirements editor

Editing Requirements

Invoking the Requirements Editor

To create, amend or delete facts about requirements, select the Requirements button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Functions

Requirements can be classified as essential or desirable. An essential requirement is one which the proposed system must have, whilst a desirable requirement is one which the proposed system may have but is not vital to the success of the system.

The Addresses problem tab shows a list of the problems which the requirement supports. The requirement can be linked to an additional problem using the Problem editor.

The Implemented by tab shows a list of processes which implements the requirement. The requirement can be linked to an additional process using the Process editor.

The Prioritisation tab shows the current ranked order of requirements priorities. See also requirements prioritisation, requirements voting completion and requirements summary.

Validation

A requirement should be implemented by at least one process unless the requirement is out of scope.

See also

Requirements

Requirements Prioritisation


Events editor

Editing Events

Invoking the Events Editor

To create, amend or delete facts about events, select the Events button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Fields

The Control message field is used to record the manner in which an event is made known to the proposed system. For example, the control message might refer to the form or document in which a customer order is created.

The Source field is used to indicate the stakeholder from which the event derives.

Specific Functions

The Event data tab displays a list of the data parameters 'carried' by the event. Additional data items can be created by placing the cursor on the box preceded by an asterisk (*), entering the name of the data item and selecting the type of the data item from the drop down list.

To delete a data item, place the cursor on the appropriate box on the left hand side of the list and press the Del key.

The Related objects tab lists the objects which are impacted by the event. To assign a new object, use the Object editor.

The Starts processes tab lists the processes which are triggered (or started) by the event. To assign a new process, use the Process editor.

See also

Events

Objects

Processes


Object editor

Editing Objects

Invoking the Objects Editor

To create, amend or delete facts about objects, select the Objects button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Functions

The Events tab displays a list of events which impact the object.

To assign further events, select the Assign event button. A list of event will be displayed from which one can be selected from the drop-down list.

To deassign a event from an object, select the event by clicking on the box to the left of the event name. A small arrow will point to the selected event. Press Deassign event to remove the event from the object's list.

The Object data tab displays a list of data items associated with the object. Additional data items can be created by placing the cursor on the box preceded by an asterisk (*), entering the name of the data item and selecting the type of the data item from the drop down list.

Check the key field to indicate whether the data item is part of the primary key of the object.

To delete a data item, place the cursor on the appropriate box on the left hand side of the list and press the Del key.

Because some data items might become objects in their own right, the Record as object button will automatically create an object entry for the currently highlighted data item.

Data items in objects are often derived from the data which is 'carried' by an event associated with an object. The Analyst Fact Workbench can suggest possible data items by selecting the Possible data items button. When pressed, a list of possible data items is suggested. This list is derived from the data items used in events associated with the object, but not yet appearing in the list of data items associated with the object.

Tip. Because of the way in which the Analyst Fact Workbench can suggested data items for objects, it is best to link all the events to associated objects before creating an object's data item list.

The Processed by tab lists the processes which manipulate the object. To assign a new process, use the Process editor.

Validation

An object should have at least one event assigned to it. Furthermore, an object should have processes which at least create instances of the object and optionally, read/update the object and delete the object.

See also

Events

Objects

Processes


Process editor

Editing Processes

Invoking the Process Editor

To create, amend or delete facts about processes, select the Processes button from the main control panel.

Standard Editing Functions

Standard editing functions are available for navigating facts, add new facts and deleting old facts. A brief history of the fact type is also maintained and accessed by selecting the History tab.

Specific Functions

The Requirements tab displays a list of requirements implemented by the process.

To assign further requirements, select the Assign requirement button. A list of requirements will be displayed from which one can be selected from the drop-down list.

To deassign a requirement from a process, select the requirement by clicking on the box to the left of the requirement name. A small arrow will point to the selected requirement. Press Deassign requirement to remove the requirement from the processes' list.

The Constraints tab displays a list of constraints which impact the process.

To assign further constraints, select the Assign constraint button. A list of constraints will be displayed from which one can be selected from the drop-down list.

To deassign a constraint from a process, select the constraint by clicking on the box to the left of the constraint name. A small arrow will point to the selected constraint . Press Deassign constraint to remove the constraint from the processes' list.

The Start events tab displays a list of events which trigger the process.

To assign further events, select the Assign event button. A list of events will be displayed from which one can be selected from the drop-down list.

To deassign a event from a process, select the event by clicking on the box to the left of the event name. A small arrow will point to the selected event. Press Deassign event to remove the event from the processes' list.

The CRUD tab displays a list of objects known to the system and the impact which the process has upon each object. The impact can be classified as Creating an instance of the object, Reading or Updating the object or Deleting the object. See also CRUD.

Validation

A process should operate upon at least one object.

See also

Events

Objects

Processes


Validation rules

General Rules for Validating the Fact Base

To find out the general rules for validating the fact base, perform the following steps:

  1. Go to the main control panel
  2. Select Reports
  3. Select Help
  4. Scroll through the report types reading the Validation section, or press Print to obtain a print out of all validation rules.

See also

Validating the fact base


Validating the Fact Base

The current number of validation errors are shown on the main control panel. A detailed validation report can be produced by selecting the Validation button.

See also

General rules for validating the fact base


Communications centre

Communicating with Team Members

The Analyst Fact Workbench is a multi-user tool which enables team members to work co-operatively.

The Communications Centre is provided to enable team members to contact one another easily by email. To access the Communications Centre, select the Communications button from the main control panel.

The Contact team tab enables the creation of free-form email messages. The Next meeting tab provides an email template for the details of the next team meeting.

Pressing the Send email button causes the selected email to be sent to team members.

Email addresses for team members should be set up using the project details template.


Issue Management

The issue board is a system where team members can record unresolved issues and questions about the current project, assign issues to team members for resolution and record the outcome of investigations.

When a team member logs on, any unresolved issues are summarised.

An issue board provides details of all issues and is accessed by pressing the Issues button on the main control panel. The control panel shows the number of unresolved issues for all team members and the number of unresolved issues for the current user.

Press Ctrl+A at any time to invoke the Issues editor to create, amend, assign or delete an issue.

See also

Issue board

Issues editor


Issue Board

The Issue Board summarises all issues recorded.

The Unresolved tab highlights only those issues which have not been resolved (irrespective of the team member to which it has been assigned).

The All my issues tab highlights all the issues assigned to the current user.

The My unresolved tab highlights all the unresolved issues assigned to the current user.

Specific Functions

Select the Add/delete all issues button to invoke the Issues editor to add, amend, assign or delete an issue.

See also

Issue management


Issue Editor

Invoking the Issue Editor

To create, amend, assign or delete an issue, either press Ctrl+A at any time or select:

  1. The Issues button from the main control panel

  2. Then select the Add/delete all issues button from the Issue Board.

Specific Fields

The Assigned to field is used to assign the issue to a team member.

The Resolved check box should be checked when the issue has been resolved.

Specific Functions

The Broadcast function is used to email the current issue to all team members.

See also

Issue board

Issue management


Reports

Check the boxes for the reports you want printed and then press Print. Possible reports include:

  • Title page, showing project details including team members. To update edit the project details. Some text on this page can also be chnaged using the project supervisor's parameters option.
  • Organisational units
  • Stakeholders
  • Problems
  • Constraints
  • Requirements
  • Requirements Voting
  • Events
  • Objects
  • Processes
  • Validation of facts
  • Summary of outstanding issues
  • Activity and team summary

For further information on individual reports, press the Help button from the Report Printing window. Use the PgUp and PgDn function keys to scroll through the different report types. Note that each report description also provides information about validating facts. Press the Print button to obtain a print out on all reports types and validation.


Activities Model

Each Analyst Fact Workbench project has an underlying process model which can be used to record project activities, produce summaries of activity and manage the project.

To view the process model for the current project, select the Activities button from the main control panel.

Project supervisors can edit, save, retrieve, import and export process models using the process model editing options available from the System button on the main control panel.

See also

Record activity

Activity summary

Process model editing


Activities Log

Each Analyst Fact Workbench project has an underlying process model which can be used to record project activities, produce summaries of activity and manage the project.

To log the details of an activity for the current project, select the Activity log button from the main control panel.

Enter the following details:

  1. The name of the team member against which the log entry is to be assigned (this does not have to be the team member currently logged in)
  2. The duration (in minutes) spent on the activity
  3. The activity, which can be selected from the drop down list which provides details of all activities defined in the process model for the project.

See also

Activities model

Activity summary


Activities Log Summary

Each Analyst Fact Workbench project has an underlying process model which can be used to record project activities, produce summaries of activity and manage the project.

To obtain a summary of activities:

  1. Press the Activity log button on the main control panel.
  2. Press the Show summary button on the Activity log window.
  3. To print the summary, press the Print summary button on the Activity summary window.

See also

Activities model

Record activity


System configuration

Accessing the system configuration options

The Analyst Fact Workbench has a number of system configuration options which can be set-up by the project supervisor.

To access the system configuration, assuming you are already logged on as a user, select the System button from the main control panel. When selected, you will be required to supply the project supervisor's password.

If you are not logged on as a user- for example, the project supervisor is not a member of the team, select the Special button from the log-in start-up dialogue. For further information see supervisor login.

If a correct supervisor's password is supplied, the the project setup/ system configuration menu is displayed.

System configuration options

A range of special system configuration options are available for project supervisors.

The Parameters button enables a project supervisor to change the parameters of a project, including the cover page text that appears when users select a Title page report. See also the parameters page.

The Process model button enables a project supervisor to edit, import and export the process models used by the Analyst Fact Workbench to record activities in the activity log. See also the process model editor page.

The Users button enables a project supervisor to change the passwords of team members. See also the changing user passwords page

The Password button enables a project supervisor to change the project supervisor's password

The System log button prints the system log.

The Clear log button deletes all entries in the activities log.

The Delete button deletes ALL data in the Analyst Fact Workbench, including team member information. This command should be used with caution.

The Special button enters the Analyst Fact Workbench into Special mode which enables certain command lines instructions to be entered. This command is not normally required. Project supervisors will only need to use this option in event of a system problem and when directed to do so by the Analyst Fact Workbench support team.

The Return button returns to the main control panel.


Special log-in

A project supervisor, who is not a named member of a project team, can log into the Analyst Fact Workbench by pressing the Special button from the main log-in dialogue andn supplying the appropriate project supervisor's password.

A named member of a team can access project setup and system configuration options by pressing the System button from the main control panel.


Project supervisor's password

The project supervisor's password is required to gain access to special project setup/system configuration options. The password is supplied with the distribution of the Analyst Fact Workbench and change be changed as a configuration option.

If you have lost the password, please contact your Analyst Fact Workbench distributor.


Changing system parameters

Accessing the system parameters form

To access the system parameters form, shown below, select the System button from the main control panel, followed by the Parameters button from the system menu.

System parameters

The Upper cover page text and Lower cover page text fields show the text displayed on the report generated when users select the Title Page report option from the reports menu.

The Monitor email address field is used to specify the email address to which certain system reports are automatically sent.

The Feedback starts field is used to specify the date on or after which users can access the feedback command available on the main control panel.

The Finalise starts field is used to specify the date on or after which users can access the finalise command available on the main control panel.


Defining the process model

Accessing the process model editor

To access the process model editor, shown below, select the System button from the main control panel, followed by the Process model button from the system menu.

Editing the process model

A process model is used by the activity log to record effort spent by team members on project tasks. A project can have a number of process models defined, but only one can be active at any one time. By default, the current process model is shown in the process model editing window.

The order in which process model steps appears is determined by the value of the Step ID field (it is shown in increasing numeric order). The Step name and Description fields name each process step and provide a detailed description of the step.

Functions are provided for adding, deleting, clearing (deleting) and printing the current process model.

Additional functions are available for storing, retrieving, importing and exporting process models.


Manipulating process models

In addition to the main process model used by the Analyst Fact Workbench to record tasks in the activity log, it is possible to define alternative process models.

Retrieving a process model

To retrieve a process model and to make it the current process model, perform the following steps:

  1. Press the System button on the main control panel.
  2. Enter the project supervisor's password.
  3. Press the Process model button
  4. Save the current process model (if necessary) using the procedure described below
  5. Press the Clear model button to clear the current model
  6. Press the Retrieve model button
  7. Select the required model from the drop-down list and press the Retrieve model button

Storing a process model

To store a process model, perform the following steps:

  1. Press the System button on the main control panel.
  2. Enter the project supervisor's password.
  3. Press the Process model button
  4. Press the Store model button
  5. Enter a name for the model and press the Store model button

Importing and Exporting process models

Process models can be stored outside the Analyst Fact Workbench as Excel worksheets.

Exporting a process model

To export a process model, you must first store the model following the instructions given above, and then follow these steps:

  1. Select the Export model button
  2. Select the name of the stored model to be exported from the drop-down list
  3. Press the Export model button
  4. The exported model will be stored in the file C:\AFWpmodel.xls

Importing a process model

To import a process model, you must first clear the current model, and then follow these steps:

  1. Select the Import model button
  2. The imported model will be retrieved from the the file C:\AFWpmodel.xls and held as the current process model.


Changing user passwords

Users can change their own passwords using the Change password option from the main control panel. In the event that users forget their passwords or the project supervisor wishes to change them, they can be amended by selecting the Users button on the project supervisor's system configuration menu.

When selected, all user names will be displayed and their current passwords shown as a series of asterisks. New passwords can be typed in and are immediately activated when the Return button is pressed.


Activities

Activity Log

  • Print out the activity log for this project
  • Record activity entries
  • Print out an activity summary


Process editor

Object Manipulation (CRUD)

Each object in a system will have a life history during which instances of the object will be created, the instances will be read and/or updated and eventually the instances will be deleted. These operations are known as CRUD or object process interaction.

Manipulation Types

Create

A create involves the creation of a new object instance. Each instance should be uniquely identifiable through an identifying key data item. To create a key, see the object editor description.

Read

A read involves a process accessing one or more instances of an object. The data item values of the object are not changed, but may be used in the output of other values or the creation or updating of other objects.

Update

An update involves a process accessing one or more instances of an object and changing the values of at least one associated data item. You should use an Update if a process is to both access data values and change them.

Delete

A delete involves the removal of one or more instances of a process.

Handling Multiple Operations

If a process is to do more than a single operation on an object, then consider the following:

  1. If you want a process to both read and update an object, use an Update operation
  2. If you want a process to both create and delete the same instance of an object, the overall effect on the object is NIL and no action should be recorded
  3. If you want a process to both create and read the same instance of an object, use a Create operation
  4. If you want a process to both create and update the same instance of an object, use a Create operation
  5. If you want a process to do anything else, separate the process into smaller processes so that there is only one operation type per object.

See also

Events

Objects

Processes


Directory

A simple directory of all known facts and their types can be retrieved by pressing the Directory button from the main control panel.


Fact history record

Fact History

A brief history of each fact type is maintained by the Analyst Fact Workbench. The history can be accessed by the History tab on each fact editing form. Details of the creation and updating of the fact are shown.


Problem Types

Not all problems will be equal in terms of their severity and impact on the business. Some problems will have solutions that enable stakeholders to work-around them, whilst others may have no immediate solution. Problem can therefore be categorised into a a series of levels: desirable, workable, severe and critical.

  • a problem which is classified as a desire is one which presents a hindrance but for which no special action is required- the problem is therefore simply a statement of wish for change, but which is unlikely to have any significant impact on the business
  • a workable problem is a problem that has a pragmatic solution which can be achieved with a reasonable degree of ease, without which there would be some impact on the business
  • a severe problem is a problem which does not have a straightforward, pragmatic solution and which has an impact on the business; a severe problem requires some form of remedy or solution within a foreseeable timescale
  • a critical problem is a problem which does not have a straightforward, pragmatic solution and which has an impact on the business; a critical problem requires an immediate form of remedy or solution, without which the business is at risk.

Note that some problems may be outside the scope of the system to be developed and therefore not addressed.


Standard Fact Editing Functions

Find a Fact

The Find function is used to locate a specific fact. Place the cursor in the field you want to search, select the Find function, enter the value you wish to find and press Find Next.

Add a New Fact

The Add function is used to create a new fact type. The Analyst Fact Workbench will clear the current form and create a new entry. New facts can also be added by using the toolbar in the bottom left of the form.

Delete an Existing Fact

The Delete function is used to delete the current fact. You cannot delete an organisational unit if it has stakeholders assigned to the unit- you will get the message 'The record cannot be delete or changed because table Stakeholders includes related records'.

Navigating Facts

At the foot of the form is a fact record navigation toolbar. The buttons perform the following functions: move to the first fact, move to the previous fact, move to the next fact, move to the last fact, create a new fact.


Analyst Fact Workbench

Welcome to Help

  • Find out about different fact types
  • Find out about the Analyst Fact Workbench facilities
  • Connect to our web site for the latest updates and information at www.co.umist.ac.uk/AFW


Validation

Validating the Fact Base

  • General rules about validating the fact base
  • Validating the contents of the fact base